<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Property List</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Property List<br/>
<small>
[<a class="el" href="group__m17nCore.html">CORE API</a>]</small>
</h1>
<p>Property List objects and API for them.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of property list objects.  <a href="#gac8b2ac3c9a8f0a6afb7f189b694035e2"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga687bcaacf8110e0f60a12c9ebc288b4c">mplist_deserialize</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Generate a property list by deserializing an M-text.  <a href="#ga687bcaacf8110e0f60a12c9ebc288b4c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga86cff73047b6462271d086f7365782ff">mplist</a> (void)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a property list object.  <a href="#ga86cff73047b6462271d086f7365782ff"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga03cb2253e439ec15d0bbbac6f86f0e37">mplist_copy</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copy a property list.  <a href="#ga03cb2253e439ec15d0bbbac6f86f0e37"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gafbfabe7a3e97e3dc6968263f61a3bee3">mplist_put</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the value of a property in a property list.  <a href="#gafbfabe7a3e97e3dc6968263f61a3bee3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga2a2f833fccd7b699eb31e5de62cea41b">mplist_get</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the value of a property in a property list.  <a href="#ga2a2f833fccd7b699eb31e5de62cea41b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gab1654476aef37dbea02c56476353ab8e">mplist_put_func</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, <a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a> func)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the value (function pointer) of a property in a property list.  <a href="#gab1654476aef37dbea02c56476353ab8e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga215ddb45ee970edbee7ff2e2e6bc1e8d">mplist_get_func</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the value (function pointer) of a property in a property list.  <a href="#ga215ddb45ee970edbee7ff2e2e6bc1e8d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gaf5d13d2df5af9260356aa415e3965def">mplist_add</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a property at the end of a property list.  <a href="#gaf5d13d2df5af9260356aa415e3965def"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga20e766b438f42a13bdee803908e6096d">mplist_push</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a property at the beginning of a property list.  <a href="#ga20e766b438f42a13bdee803908e6096d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gae05459bfe72a34eefe5a04b4aa75d20a">mplist_pop</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove a property at the beginning of a property list.  <a href="#gae05459bfe72a34eefe5a04b4aa75d20a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga73caf1b7a0082184ff15e1b3e2da8969">mplist_find_by_key</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Find a property of a specific key in a property list.  <a href="#ga73caf1b7a0082184ff15e1b3e2da8969"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gaeb782bf76f84a8620331c8de70d43ba7">mplist_find_by_value</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Find a property of a specific value in a property list.  <a href="#gaeb782bf76f84a8620331c8de70d43ba7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga5c7598c133f6a177a2ad5781fc712f6e">mplist_next</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the next sublist of a property list.  <a href="#ga5c7598c133f6a177a2ad5781fc712f6e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#gab343caba712200f5324c12f668f7e6da">mplist_set</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the first property in a property list.  <a href="#gab343caba712200f5324c12f668f7e6da"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga334646ff9553354f4b041947f000764d">mplist_length</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the length of a property list.  <a href="#ga334646ff9553354f4b041947f000764d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga79d757b26382412e7ea69e914bc06a07">mplist_key</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the key of the first property in a property list.  <a href="#ga79d757b26382412e7ea69e914bc06a07"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga855f3010b216bcf5f0914553fc034295">mplist_value</a> (<a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Return the value of the first property in a property list.  <a href="#ga855f3010b216bcf5f0914553fc034295"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8">Minteger</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "integer".  <a href="#ga0ce08eb57aa339db4d4745e75e80fdd8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga933000e154873f9bfcaa56d976bd259b">Mplist</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "plist".  <a href="#ga933000e154873f9bfcaa56d976bd259b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nPlist.html#ga1a22859374071a0ca66f12452afee8bd">Mtext</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "mtext".  <a href="#ga1a22859374071a0ca66f12452afee8bd"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Property List objects and API for them. </p>
<p>A <em>property</em> <em>list</em> (or <em>plist</em> for short) is a list of zero or more properties. A property consists of a <em>key</em> and a <em>value</em>, where key is a symbol and value is anything that can be cast to <code>(void *)</code>.</p>
<p>If the key of a property is a <em>managing</em> <em>key</em>, its <em>value</em> is a <em>managed</em> <em>object</em>. A property list itself is a managed objects.</p>
<p>If each key of a plist is one of <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb" title="Symbol whose name is &quot;symbol&quot;.">Msymbol</a>, <a class="el" href="group__m17nPlist.html#ga1a22859374071a0ca66f12452afee8bd" title="Symbol whose name is &quot;mtext&quot;.">Mtext</a>, <a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8" title="Symbol whose name is &quot;integer&quot;.">Minteger</a>, and <a class="el" href="group__m17nPlist.html#ga933000e154873f9bfcaa56d976bd259b" title="Symbol whose name is &quot;plist&quot;.">Mplist</a>, the plist is called as <em>well-formed</em> and represented by the following notation in the documentation.</p>
<div class="fragment"><pre class="fragment">
      PLIST ::= '(' ELEMENT * ')'

      ELEMENT ::= INTEGER | SYMBOL | M-TEXT | PLIST

      M-TEXT ::= '"' text data ... '"'
</pre></div><p>For instance, if a plist has four elements; integer -20, symbol of name "sym", M-text of contents "abc", and plist of integer 10 and symbol of name "another-symbol", it is represented as this:</p>
<p>(-20 sym "abc" (10 another-symbol)) </p>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="gac8b2ac3c9a8f0a6afb7f189b694035e2"></a><!-- doxytag: member="m17n&#45;core.h::MPlist" ref="gac8b2ac3c9a8f0a6afb7f189b694035e2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of property list objects. </p>
<p>The type <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2" title="Type of property list objects.">MPlist</a> is for a <em>property</em> <em>list</em> object. Its internal structure is concealed from application programs. </p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga687bcaacf8110e0f60a12c9ebc288b4c"></a><!-- doxytag: member="m17n&#45;core.h::mplist_deserialize" ref="ga687bcaacf8110e0f60a12c9ebc288b4c" args="(MText *mt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> * mplist_deserialize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generate a property list by deserializing an M-text. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga687bcaacf8110e0f60a12c9ebc288b4c" title="Generate a property list by deserializing an M-text.">mplist_deserialize()</a> function parses M-text <b>mt</b> and returns a property list.</p>
<p>The syntax of <b>mt</b> is as follows.</p>
<p>MT ::= '(' ELEMENT * ')'</p>
<p>ELEMENT ::= SYMBOL | INTEGER | M-TEXT | PLIST</p>
<p>SYMBOL ::= ascii-character-sequence</p>
<p>INTEGER ::= '-' ? [ '0' | .. | '9' ]+ | '0x' [ '0' | .. | '9' | 'A' | .. | 'F' | 'a' | .. | 'f' ]+</p>
<p>M-TEXT ::= '"' character-sequence '"'</p>
<p>Each alternatives of <code>ELEMENT</code> is assigned one of these keys: <code>Msymbol</code>, <code>Minteger</code>, <code>Mtext</code>, <code>Mplist</code> </p>
<p>In an ascii-character-sequence, a backslash (\) is used as the escape character, which means that, for instance, <code>abc\ def</code> produces a symbol whose name is of length seven with the fourth character being a space. </p>

</div>
</div>
<a class="anchor" id="ga86cff73047b6462271d086f7365782ff"></a><!-- doxytag: member="plist.c::mplist" ref="ga86cff73047b6462271d086f7365782ff" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a property list object. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga86cff73047b6462271d086f7365782ff" title="Create a property list object.">mplist()</a> function returns a newly created property list object of length zero.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns a newly created property list.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>This function never fails. </dd></dl>

</div>
</div>
<a class="anchor" id="ga03cb2253e439ec15d0bbbac6f86f0e37"></a><!-- doxytag: member="plist.c::mplist_copy" ref="ga03cb2253e439ec15d0bbbac6f86f0e37" args="(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_copy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copy a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga03cb2253e439ec15d0bbbac6f86f0e37" title="Copy a property list.">mplist_copy()</a> function copies property list <b>plist</b>. In the copy, the values are the same as those of <b>plist</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns a newly created plist which is a copy of <b>plist</b>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>This function never fails. </dd></dl>

</div>
</div>
<a class="anchor" id="gafbfabe7a3e97e3dc6968263f61a3bee3"></a><!-- doxytag: member="plist.c::mplist_put" ref="gafbfabe7a3e97e3dc6968263f61a3bee3" args="(MPlist *plist, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_put </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the value of a property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#gafbfabe7a3e97e3dc6968263f61a3bee3" title="Set the value of a property in a property list.">mplist_put()</a> function searches property list <b>plist</b> from the beginning for a property whose key is <b>key</b>. If such a property is found, its value is changed to <b>value</b>. Otherwise, a new property whose key is <b>key</b> and value is <b>value</b> is appended at the end of <b>plist</b>. See the documentation of <a class="el" href="group__m17nPlist.html#gaf5d13d2df5af9260356aa415e3965def" title="Add a property at the end of a property list.">mplist_add()</a> for the restriction on <b>key</b> and <b>val</b>.</p>
<p>If <b>key</b> is a managing key, <b>val</b> must be a managed object. In this case, the reference count of the old value, if not <code>NULL</code>, is decremented by one, and that of <b>val</b> is incremented by one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nPlist.html#gafbfabe7a3e97e3dc6968263f61a3bee3" title="Set the value of a property in a property list.">mplist_put()</a> returns a sublist of <b>plist</b> whose first element is the just modified or added one. Otherwise, it returns <code>NULL</code>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga2a2f833fccd7b699eb31e5de62cea41b"></a><!-- doxytag: member="plist.c::mplist_get" ref="ga2a2f833fccd7b699eb31e5de62cea41b" args="(MPlist *plist, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mplist_get </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of a property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga2a2f833fccd7b699eb31e5de62cea41b" title="Get the value of a property in a property list.">mplist_get()</a> function searches property list <b>plist</b> from the beginning for a property whose key is <b>key</b>. If such a property is found, its value is returned as the type of <code>(void *)</code>. If not found, <code>NULL</code> is returned.</p>
<p>When <code>NULL</code> is returned, there are two possibilities: one is the case where no property is found (see above); the other is the case where a property is found and its value is <code>NULL</code>. In case that these two cases must be distinguished, use the <a class="el" href="group__m17nPlist.html#ga73caf1b7a0082184ff15e1b3e2da8969" title="Find a property of a specific key in a property list.">mplist_find_by_key()</a> function.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nPlist.html#ga73caf1b7a0082184ff15e1b3e2da8969" title="Find a property of a specific key in a property list.">mplist_find_by_key()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gab1654476aef37dbea02c56476353ab8e"></a><!-- doxytag: member="plist.c::mplist_put_func" ref="gab1654476aef37dbea02c56476353ab8e" args="(MPlist *plist, MSymbol key, M17NFunc func)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_put_func </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a>&nbsp;</td>
          <td class="paramname"> <em>func</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the value (function pointer) of a property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#gab1654476aef37dbea02c56476353ab8e" title="Set the value (function pointer) of a property in a property list.">mplist_put_func()</a> function is similar to <a class="el" href="group__m17nPlist.html#gafbfabe7a3e97e3dc6968263f61a3bee3" title="Set the value of a property in a property list.">mplist_put()</a> but for setting function pointer <b>func</b> in property list <b>plist</b> for key <b>key</b>. <b>key</b> must not be a managing key.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nPlist.html#gafbfabe7a3e97e3dc6968263f61a3bee3" title="Set the value of a property in a property list.">mplist_put()</a>, <a class="el" href="group__m17nCore.html#ga56e45d7b0345761359001fe038d121ae" title="Wrapper for a generic function type.">M17N_FUNC()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga215ddb45ee970edbee7ff2e2e6bc1e8d"></a><!-- doxytag: member="plist.c::mplist_get_func" ref="ga215ddb45ee970edbee7ff2e2e6bc1e8d" args="(MPlist *plist, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a> mplist_get_func </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value (function pointer) of a property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga215ddb45ee970edbee7ff2e2e6bc1e8d" title="Get the value (function pointer) of a property in a property list.">mplist_get_func()</a> function is similar to <a class="el" href="group__m17nPlist.html#ga2a2f833fccd7b699eb31e5de62cea41b" title="Get the value of a property in a property list.">mplist_get()</a> but for getting a function pointer from property list <b>plist</b> by key <b>key</b>.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nPlist.html#ga2a2f833fccd7b699eb31e5de62cea41b" title="Get the value of a property in a property list.">mplist_get()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gaf5d13d2df5af9260356aa415e3965def"></a><!-- doxytag: member="plist.c::mplist_add" ref="gaf5d13d2df5af9260356aa415e3965def" args="(MPlist *plist, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_add </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a property at the end of a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#gaf5d13d2df5af9260356aa415e3965def" title="Add a property at the end of a property list.">mplist_add()</a> function appends at the end of property list <b>plist</b> a property whose key is <b>key</b> and value is <b>val</b>. <b>key</b> can be any symbol other than <code>Mnil</code>.</p>
<p>If <b>key</b> is a managing key, <b>val</b> must be a managed object. In this case, the reference count of <b>val</b> is incremented by one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nPlist.html#gaf5d13d2df5af9260356aa415e3965def" title="Add a property at the end of a property list.">mplist_add()</a> returns a sublist of <b>plist</b> whose first element is the just added one. Otherwise, it returns <code>NULL</code>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga20e766b438f42a13bdee803908e6096d"></a><!-- doxytag: member="plist.c::mplist_push" ref="ga20e766b438f42a13bdee803908e6096d" args="(MPlist *plist, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_push </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a property at the beginning of a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga20e766b438f42a13bdee803908e6096d" title="Add a property at the beginning of a property list.">mplist_push()</a> function inserts at the beginning of property list <b>plist</b> a property whose key is <b>key</b> and value is <b>val</b>.</p>
<p>If <b>key</b> is a managing key, <b>val</b> must be a managed object. In this case, the reference count of <b>val</b> is incremented by one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, this function returns <b>plist</b>. Otherwise, it returns <code>NULL</code>. </dd></dl>

</div>
</div>
<a class="anchor" id="gae05459bfe72a34eefe5a04b4aa75d20a"></a><!-- doxytag: member="plist.c::mplist_pop" ref="gae05459bfe72a34eefe5a04b4aa75d20a" args="(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mplist_pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a property at the beginning of a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#gae05459bfe72a34eefe5a04b4aa75d20a" title="Remove a property at the beginning of a property list.">mplist_pop()</a> function removes a property at the beginning of property list <b>plist</b>. As a result, the second key and value of the <b>plist</b> become the first ones.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, this function return the value of the just popped property. Otherwise, it returns <code>NULL</code>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga73caf1b7a0082184ff15e1b3e2da8969"></a><!-- doxytag: member="plist.c::mplist_find_by_key" ref="ga73caf1b7a0082184ff15e1b3e2da8969" args="(MPlist *plist, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_find_by_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Find a property of a specific key in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga73caf1b7a0082184ff15e1b3e2da8969" title="Find a property of a specific key in a property list.">mplist_find_by_key()</a> function searches property list <b>plist</b> from the beginning for a property whose key is <b>key</b>. If such a property is found, a sublist of <b>plist</b> whose first element is the found one is returned. Otherwise, <code>NULL</code> is returned.</p>
<p>If <b>key</b> is <code>Mnil</code>, it returns a sublist of <b>plist</b> whose first element is the last one of <b>plist</b>. </p>

</div>
</div>
<a class="anchor" id="gaeb782bf76f84a8620331c8de70d43ba7"></a><!-- doxytag: member="plist.c::mplist_find_by_value" ref="gaeb782bf76f84a8620331c8de70d43ba7" args="(MPlist *plist, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_find_by_value </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Find a property of a specific value in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#gaeb782bf76f84a8620331c8de70d43ba7" title="Find a property of a specific value in a property list.">mplist_find_by_value()</a> function searches property list <b>plist</b> from the beginning for a property whose value is <b>val</b>. If such a property is found, a sublist of <b>plist</b> whose first element is the found one is returned. Otherwise, <code>NULL</code> is returned. </p>

</div>
</div>
<a class="anchor" id="ga5c7598c133f6a177a2ad5781fc712f6e"></a><!-- doxytag: member="plist.c::mplist_next" ref="ga5c7598c133f6a177a2ad5781fc712f6e" args="(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_next </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the next sublist of a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga5c7598c133f6a177a2ad5781fc712f6e" title="Return the next sublist of a property list.">mplist_next()</a> function returns a pointer to the sublist of property list <b>plist</b>, which begins at the second element in <b>plist</b>. If the length of <b>plist</b> is zero, it returns <code>NULL</code>. </p>

</div>
</div>
<a class="anchor" id="gab343caba712200f5324c12f668f7e6da"></a><!-- doxytag: member="plist.c::mplist_set" ref="gab343caba712200f5324c12f668f7e6da" args="(MPlist *plist, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* mplist_set </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the first property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#gab343caba712200f5324c12f668f7e6da" title="Set the first property in a property list.">mplist_set()</a> function sets the key and the value of the first property in property list <b>plist</b> to <b>key</b> and <b>value</b>, respectively. See the documentation of <a class="el" href="group__m17nPlist.html#gaf5d13d2df5af9260356aa415e3965def" title="Add a property at the end of a property list.">mplist_add()</a> for the restriction on <b>key</b> and <b>val</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nPlist.html#gab343caba712200f5324c12f668f7e6da" title="Set the first property in a property list.">mplist_set()</a> returns <b>plist</b>. Otherwise, it returns <code>NULL</code>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga334646ff9553354f4b041947f000764d"></a><!-- doxytag: member="plist.c::mplist_length" ref="ga334646ff9553354f4b041947f000764d" args="(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mplist_length </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the length of a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga334646ff9553354f4b041947f000764d" title="Return the length of a property list.">mplist_length()</a> function returns the number of properties in property list <b>plist</b>. </p>

</div>
</div>
<a class="anchor" id="ga79d757b26382412e7ea69e914bc06a07"></a><!-- doxytag: member="plist.c::mplist_key" ref="ga79d757b26382412e7ea69e914bc06a07" args="(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mplist_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the key of the first property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga79d757b26382412e7ea69e914bc06a07" title="Return the key of the first property in a property list.">mplist_key()</a> function returns the key of the first property in property list <b>plist</b>. If the length of <b>plist</b> is zero, it returns <code>Mnil</code>. </p>

</div>
</div>
<a class="anchor" id="ga855f3010b216bcf5f0914553fc034295"></a><!-- doxytag: member="plist.c::mplist_value" ref="ga855f3010b216bcf5f0914553fc034295" args="(MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mplist_value </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the value of the first property in a property list. </p>
<p>The <a class="el" href="group__m17nPlist.html#ga855f3010b216bcf5f0914553fc034295" title="Return the value of the first property in a property list.">mplist_value()</a> function returns the value of the first property in property list <b>plist</b>. If the length of <b>plist</b> is zero, it returns <code>NULL</code>. </p>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ga0ce08eb57aa339db4d4745e75e80fdd8"></a><!-- doxytag: member="plist.c::Minteger" ref="ga0ce08eb57aa339db4d4745e75e80fdd8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8">Minteger</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "integer". </p>
<p>The symbol <code>Minteger</code> has the name <code>"integer"</code>. The value of a property whose key is <code>Minteger</code> must be an integer. </p>

</div>
</div>
<a class="anchor" id="ga933000e154873f9bfcaa56d976bd259b"></a><!-- doxytag: member="plist.c::Mplist" ref="ga933000e154873f9bfcaa56d976bd259b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nPlist.html#ga933000e154873f9bfcaa56d976bd259b">Mplist</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "plist". </p>
<p>The symbol <code>Mplist</code> has the name <code>"plist"</code>. It is a managing key. A value of a property whose key is <code>Mplist</code> must be a plist. </p>

</div>
</div>
<a class="anchor" id="ga1a22859374071a0ca66f12452afee8bd"></a><!-- doxytag: member="plist.c::Mtext" ref="ga1a22859374071a0ca66f12452afee8bd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nPlist.html#ga1a22859374071a0ca66f12452afee8bd">Mtext</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "mtext". </p>
<p>The symbol <code>Mtext</code> has the name <code>"mtext"</code>. It is a managing key. A value of a property whose key is <code>Mtext</code> must be an M-text. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
